Serial Wombat Arduino Library

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
SerialWombatQueue Class Reference

A Class representing a Queue in the User Ram area on the Serial Wombat Chip. More...

`#include <SerialWombatQueue.h>`

Inheritance diagram for SerialWombatQueue:
[legend]
Collaboration diagram for SerialWombatQueue:
[legend]

## Public Member Functions
| SerialWombatQueue (SerialWombatChip &serialWombat)
| Constructor for SerialWombatWS2812 class /.
int16_t | begin (uint16_t index, uint16_t length, SerialWombatQueueType qtype=SerialWombatQueueType::QUEUE_TYPE_RAM_BYTE)
| Initialize a Serial Wombat Queue (RAM Bytes) in User Memory Area on Serial Wombat Chip / /.
int | available ()
| Queries the Serial Wombat for number bytes available to read /.
int | read ()
| Reads a byte from the Serial Wombat /.
void | flush ()
| Discard all received bytes.
int | peek ()
| Query the Serial Wombat for the next avaialble byte, but don't remove it from the queue /.
size_t | write (uint8_t data)
| Write a byte to the Serial Wombat Queue /.
size_t | write (uint16_t data)
| Write an unsigned word to the Serial Wombat Queue /.
size_t | write (uint16_t buffer[], size_t size)
| Write unsigned words to the Serial Wombat Queue /.
size_t | write (const uint16_t *buffer, size_t size)
| Write unsigned words to the Serial Wombat Queue /.
size_t | write (const uint8_t *buffer, size_t size)
| Write bytes to the Serial Wombat Queue /.
int | availableForWrite ()
| Queries the Serial Wombat for the amount of free queue space /.
size_t | readBytes (char *buffer, size_t length)
| Reads a specified number of bytes from the Serial Wombat Queue /.
void | setTimeout (long timeout_mS)
size_t | readUInt16 (uint16_t *buffer, size_t length)
| Reads a specified number of unsigned 16 bit words from the Serial Wombat Queue /.

## Public Attributes
uint16_t | startIndex = 0xFFFF
uint16_t | length = 0

## Detailed Description

A Class representing a Queue in the User Ram area on the Serial Wombat Chip.

Definition at line 41 of file SerialWombatQueue.h.

## Constructor & Destructor Documentation

## ◆ SerialWombatQueue()

SerialWombatQueue::SerialWombatQueue | ( | SerialWombatChip & | serialWombat | ) |
| inline

Constructor for SerialWombatWS2812 class /.

/

Parameters

  serialWombat | SerialWombat chip on which the driver will run

Definition at line 48 of file SerialWombatQueue.h.

## Member Function Documentation

## ◆ available()

int SerialWombatQueue::available | ( |  | ) |
| inline

Queries the Serial Wombat for number bytes available to read /.

/

Returns
  Number of bytes available to read.

Definition at line 83 of file SerialWombatQueue.h.

## ◆ availableForWrite()

int SerialWombatQueue::availableForWrite | ( |  | ) |
| inline

Queries the Serial Wombat for the amount of free queue space /.

/

Returns
  Number of bytes avaialable

Definition at line 314 of file SerialWombatQueue.h.

## ◆ begin()

int16_t SerialWombatQueue::begin | ( | uint16_t | index,
|  | uint16_t | length,
|  | SerialWombatQueueType | qtype = SerialWombatQueueType::QUEUE_TYPE_RAM_BYTE )
| inline

Initialize a Serial Wombat Queue (RAM Bytes) in User Memory Area on Serial Wombat Chip / /.

/

Parameters

  index | An index in bytes for the beginning of the Queue location in Serial Wombat User Memory Area /
  length | The length in bytes of avaialble queue space /
  qtype | The type of queue to initialize (SerialWombatQueueType::QUEUE_TYPE_RAM_BYTE or SerialWombatQueueType::QUEUE_TYPE_RAM_BYTE_SHIFT) /

Returns
  A positive number indicating the number of bytes used in User Memory Area (Will be more than / length due to queue management variables) or a negative number indicating an error code.

Definition at line 62 of file SerialWombatQueue.h.

## ◆ flush()

void SerialWombatQueue::flush | ( |  | ) |
| inline

Discard all received bytes.

/

Definition at line 113 of file SerialWombatQueue.h.

## ◆ peek()

int SerialWombatQueue::peek | ( |  | ) |
| inline

Query the Serial Wombat for the next avaialble byte, but don't remove it from the queue /.

/

Returns
  A byte from 0-255, or -1 if no bytes were avaialble

Definition at line 121 of file SerialWombatQueue.h.

## ◆ read()

int SerialWombatQueue::read | ( |  | ) |
| inline

Reads a byte from the Serial Wombat /.

/

Returns
  A byte from 0-255, or -1 if no bytes were avaialble

Definition at line 98 of file SerialWombatQueue.h.

## ◆ readBytes()

size_t SerialWombatQueue::readBytes | ( | char * | buffer,
|  | size_t | length )
| inline

Reads a specified number of bytes from the Serial Wombat Queue /.

/

Parameters

  buffer | An array into which to put received bytes /
  length | The maximum number of bytes to be received /

Returns
  the number of bytes written to buffer / / This function will read bytes from the Serial Wombat Queue into buffer. / If 'length' characters are not available to read then the value returned / will be less than length.

Definition at line 336 of file SerialWombatQueue.h.

## ◆ readUInt16()

size_t SerialWombatQueue::readUInt16 | ( | uint16_t * | buffer,
|  | size_t | length )
| inline

Reads a specified number of unsigned 16 bit words from the Serial Wombat Queue /.

/

Parameters

  buffer | An array into which to put received words /
  length | The maximum number of words (not bytes) to be received /

Returns
  the number of words written to buffer / / This function will read bytes from the Serial Wombat Queue into buffer. / If 'length' characters are not available to read then the value returned / will be less than length.

Definition at line 409 of file SerialWombatQueue.h.

## ◆ setTimeout()

void SerialWombatQueue::setTimeout | ( | long | timeout_mS | ) |
| inline

Definition at line 394 of file SerialWombatQueue.h.

## ◆ write() [1/5]

size_t SerialWombatQueue::write | ( | const uint16_t * | buffer,
|  | size_t | size )
| inline

Write unsigned words to the Serial Wombat Queue /.

/

Parameters

  buffer | An array of uint16_t words to send /
  size | the number of words (not bytes) to send /

Returns
  the number of words sent / / This function queries the Serial Wombat Queue / buffer space, and sends words as buffer space is avaialble. / If avaialable buffer space is not sufficient to send the entire / array then the function will block and continue trying until the / entire message has been sent to the Serial Wombat queue.

Definition at line 203 of file SerialWombatQueue.h.

## ◆ write() [2/5]

size_t SerialWombatQueue::write | ( | const uint8_t * | buffer,
|  | size_t | size )
| inline

Write bytes to the Serial Wombat Queue /.

/

Parameters

  buffer | An array of uint8_t bytes to send /
  size | the number of bytes to send /

Returns
  the number of bytes sent / / This function queries the Serial Wombat Queue / buffer space, and sends bytes as buffer space is avaialble. / If avaialable buffer space is not sufficient to send the entire / array then the function will block and continue trying until the / entire message has been sent to the Serial Wombat queue.

Definition at line 220 of file SerialWombatQueue.h.

## ◆ write() [3/5]

size_t SerialWombatQueue::write | ( | uint16_t | buffer[],
|  | size_t | size )
| inline

Write unsigned words to the Serial Wombat Queue /.

/

Parameters

  buffer | An array of uint16_t words to send /
  size | the number of words (not bytes) to send /

Returns
  the number of words sent / / This function queries the Serial Wombat Queue / buffer space, and sends words as buffer space is avaialble. / If avaialable buffer space is not sufficient to send the entire / array then the function will block and continue trying until the / entire message has been sent to the Serial Wombat queue.

Definition at line 186 of file SerialWombatQueue.h.

## ◆ write() [4/5]

size_t SerialWombatQueue::write | ( | uint16_t | data | ) |
| inline

Write an unsigned word to the Serial Wombat Queue /.

/

Parameters

  data | Word to write /

Returns
  Number of bytes written

Definition at line 160 of file SerialWombatQueue.h.

## ◆ write() [5/5]

size_t SerialWombatQueue::write | ( | uint8_t | data | ) |
| inline

Write a byte to the Serial Wombat Queue /.

/

Parameters

  data | Byte to write /

Returns
  Number of bytes written

Definition at line 141 of file SerialWombatQueue.h.

## Member Data Documentation

## ◆ length

uint16_t SerialWombatQueue::length = 0

Definition at line 392 of file SerialWombatQueue.h.

## ◆ startIndex

uint16_t SerialWombatQueue::startIndex = 0xFFFF

Definition at line 391 of file SerialWombatQueue.h.